library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity tb_flanke is
end tb_flanke;

architecture a_tb_flanke of tb_flanke is
-- eingänge
signal i_ruf:std_logic := '0';
signal i_ziffer_wahl:std_logic := '0';
signal i_nummer_unvollstaendig:std_logic := '0';
signal i_verbunden:std_logic := '0';
signal i_verbinden:std_logic := '0';
signal i_besetzt:std_logic := '0';
signal i_abbruch:std_logic := '0';
signal i_auflegen:std_logic := '0';
signal i_antwort:std_logic := '0';
-- ausgänge
signal o_besetzt_ton:std_logic := '0';
signal o_klingel_ton:std_logic := '0';
-- synchrones Schaltwerk
signal i_reset:std_logic := '1';
signal i_clk:std_logic := '0';

component handy is
    port (
        -- eingänge
        i_ruf: in std_logic;
        i_ziffer_wahl: in std_logic;
        i_nummer_unvollstaendig: in std_logic;
        i_verbunden: in std_logic;
        i_verbinden: in std_logic;
        i_besetzt: in std_logic;
        i_abbruch: in std_logic;
        i_auflegen: in std_logic;
        i_antwort: in std_logic;
        -- ausgänge
        o_besetzt_ton: out std_logic;
        o_klingel_ton: out std_logic;
        -- synchrones Schaltwerk
        i_reset: in std_logic;
        i_clk: in std_logic
        
);
end component handy;

begin
p1:process -- ein einfacher Tacktgenerator
begin
wait for 3 ns;
i_clk <= '1';
wait for 3 ns;
i_clk <= '0';
i_reset <= '0';
end process;

sim:process
begin
    wait for  7 ns;
    i_ruf <= '1';
    wait for  6 ns;
    i_ruf <= '0';
    i_ziffer_wahl <= '1';
    wait for  6 ns;
    i_ziffer_wahl <= '0';
    i_verbinden <= '1';
    wait for  7 ns;
    i_verbinden <= '0';
    i_besetzt <= '1';
    wait for  1 ns;
    i_besetzt <= '0';
    i_abbruch <= '0';
    --i_wake_up <= '0';
    wait for  500 ns;
end process;

inst_fsm:handy port map(
        -- eingänge
        i_ruf,
        i_ziffer_wahl,
        i_nummer_unvollstaendig,
        i_verbunden,
        i_verbinden,
        i_besetzt,
        i_abbruch,
        i_auflegen,
        i_antwort,
        -- ausgänge
        o_besetzt_ton,
        o_klingel_ton,
        -- synchrones Schaltwerk
        i_reset,
        i_clk
);
--inst_vor:vorder_flanke
--port map (tb_C_in,tb_C_out_VorderFlanke);
--inst_rueck:rueck_flanke
--port map (tb_C_in,tb_C_out_RueckFlanke);
--inst_beid:beid_flanke
--port map (tb_C_in,tb_C_out_BeidFlanke);

end architecture;


